using System;
using System.IO;
using System.Collections.Generic;

namespace Exercises_C_Sharp.E19_Überladung
{
    class Exercise_5
    {
        //Beim Aufruf der Methode Analyze soll man einen String, einen Integer, einen Character oder einen Double übergeben können. Dabei soll die Methode jeweils den Typ der Variablen auf die Konsole schreiben. Zusätzlich soll zu einem String die Länge ausgegeben werden, zu einem Integer die Anzahl der Stellen, zu einem Character die dezimale Darstellung und zu einem Double die Anzahl der Nachkommastellen. Nutzen Sie dafür Überladungen der Mehtode Analyze.
        
        //Ausgabebeispiel:
        //Das übergebene Element ist ein Double. Dieser besitzt 3 Nachkommastellen.
        //Das übergebene Element ist ein Character mit der dezimalen Codierung 83.
        //Das übergebene Element ist ein String mit der Länge 10.
        //usw....

        public static void Start()
        {
            Analyze(44.343);
            Analyze('S');
            Analyze("Teststring");
            Analyze(390);
            Analyze(33.00000);
            Analyze(1209);
            Analyze('c');
        }

        //Code START
        static void Analyze(double d)
        {
            int i = 0;
            if(d.ToString().IndexOf(",") != -1)
                i = d.ToString().Length - d.ToString().IndexOf(",") + 1;
            Console.WriteLine("{0} ist ein Double mit {1} Nachkommastellen.", d, i);

            //Lösung 2:
            int k = (d - (int)d).ToString().Length - 2;

            //Lösung 3:
            double dd = (d - (int)d);
            int counter = 0;
            while(dd != 0)
            {
                dd = (d - (int)d);
                counter++;
                dd *= 10;
            }

        }
        static void Analyze(char d)
        {
            Console.WriteLine("{0} ist ein Char und hat den numerischen Wert {1}", d, (int)d);
        }
        static void Analyze(string d)
        {
            Console.WriteLine("{0} ist ein String und hat die Länge {1}", d, d.Length);
        }
        static void Analyze(int d)
        {
            Console.WriteLine("{0} ist ein Integer und hat {1} Ziffern", d, d.ToString().Length);
        }
        //Code ENDE
    }
}